from random import Random
from typing import Optional

class BoardGenerator:
    dice: list[str]
    rng: Random

    def __init__(self, seed: Optional[int]):
        self.dice = [
            'aeaneg',
            'wngeeh',
            'ahspco',
            'lnhnrz',
            'aspffk',
            'tstiyd',
            'objoab',
            'owtoat',
            'iotmuc',
            'erttyl',
            'ryvdel',
            'toessi',
            'lreixd',
            'terwhv',
            'eiunes',
            'nuihmq'
        ]
        self.rng = Random(seed)
    
    def generate_board(self) -> list[list[str]]:
        shuffled_dice = self.rng.sample(self.dice, k=len(self.dice))
        roll_results = [self.rng.choice(die) for die in shuffled_dice]
        return [roll_results[4 * i : 4 * (i+1)] for i in range(0, 4)]
